# MatLoad

Loads a matrix that has been stored in binary format with MatView(). The matrix format is determined from the options database. Generates a parallel MPI matrix if the communicator has more than one processor. The default matrix type is AIJ.

### Synopsis

    #include "petscmat.h"
    PetscErrorCode PETSCMAT_DLLEXPORT MatLoad(PetscViewer viewer, MatType outtype,Mat *newmat)

Collective on PetscViewer

### Input Parameters

| viewer | - binary file viewer, created with PetscViewerBinaryOpen()
| outtype | - type of matrix desired, for example MATSEQAIJ, MATMPIROWBS, etc. See types in petsc/include/petscmat.h.

### Output Parameters

newmat -new matrix

### Basic Options Database Keys

| -matload_type seqaij | - AIJ type
| -matload_type mpiaij | - parallel AIJ type
| -matload_type seqbaij | - block AIJ type
| -matload_type mpibaij | - parallel block AIJ type
| -matload_type seqsbaij | - block symmetric AIJ type
| -matload_type mpisbaij | - parallel block symmetric AIJ type
| -matload_type seqbdiag | - block diagonal type
| -matload_type mpibdiag | - parallel block diagonal type
| -matload_type mpirowbs | - parallel rowbs type
| -matload_type seqdense | - dense type
| -matload_type mpidense | - parallel dense type
| -matload_symmetric | - matrix in file is symmetric

### More Options Database Keys

Used with block matrix formats (MATSEQBAIJ, MATMPIBDIAG, ...) to specify block size
-matload_block_size <bs> - Used to specify block diagonal numbers for MATSEQBDIAG and MATMPIBDIAG formats
-matload_bdiag_diags <s1,s2,s3,...> -

### C++ variants

| Mat MatLoad(PetscViewer v,MatType t) |  | -> |  | MatLoad(v,t,&a); return a;

### Notes

MatLoad() automatically loads into the options database any options given in the file filename.info where filename is the name of the file that was passed to the PetscViewerBinaryOpen(). The options in the info file will be ignored if you use the -viewer_binary_skip_info option.

In parallel, each processor can load a subset of rows (or the entire matrix). This routine is especially useful when a large matrix is stored on disk and only part of it existsis desired on each processor. For example, a parallel solver may access only some of the rows from each processor. The algorithm used here reads relatively small blocks of data rather than reading the entire matrix and then subsetting it.

### Notes for advanced users

Most users should not need to know the details of the binary storage format, since MatLoad() and MatView() completely hide these details. But for anyone who's interested, the standard binary matrix storage format is

       int    MAT_FILE_COOKIE

       int    number of rows

       int    number of columns

       int    total number of nonzeros

       int    *number nonzeros in each row

       int    *column indices of all nonzeros (starting index is zero)

       PetscScalar *values of all nonzeros

PETSc automatically does the byte swapping for machines that store the bytes reversed, e.g. DEC alpha, freebsd, linux, Windows and the paragon; thus if you write your own binary read/write routines you have to swap the bytes; see PetscBinaryRead() and PetscBinaryWrite() to see how this may be done.

### Keywords

matrix, load, binary, input

### See Also

PetscViewerBinaryOpen(), MatView(), VecLoad()

Level:beginner
Location: src/mat/utils/matio.c
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages

### Examples

src/mat/examples/tutorials/ex1.c.html
src/mat/examples/tutorials/ex4.c.html
src/ksp/ksp/examples/tutorials/ex10.c.html
src/ksp/ksp/examples/tutorials/ex27.c.html